#include<stdio.h>
#include<stdlib.h>
#include<math.h>
#include"meteor2.h"

#define SITE_MAX 500
#define RAD_MAX 100

#define pi 3.1415926535898              // PI
#define pi2 1.5707963268                // PI/2
#define d2r 3.1415926535898/180.0       // zamiana katow na radiany
#define r2d 180/3.1415926535898         // i w druga strone
#define e 23.439                        // nachylenie ekliptyki do rownika


FILE*OBS;
FILE*RAD;
FILE*RAD_EKL;
FILE*SITE;

int main(int argc,char *argv[])
{

// 999.99 +99.99 999.99 +99.99 +03.0 26 34014 DORDA 000 22 23 08 2003 20 32 001 SPO

// OBS 1-event

double ra[2], dec[2], mag, vel;
int imoplace, dayb, daye, mnt, year, ho, min, no;
char code[5], idobs[3], class[3];

// SITE all places

int pl_code[SITE_MAX];
char sig1, sig2;
double pl_long[SITE_MAX], pl_lat[SITE_MAX];
int pl_n=0;

// RAD all radiants in file

char rad[RAD_MAX][3];
double r_ra[RAD_MAX], r_dec[RAD_MAX];
int r_date[RAD_MAX][6];
double r_vel[RAD_MAX], r_a[RAD_MAX], r_b[RAD_MAX];
int stat[RAD_MAX][7];
double prob[RAD_MAX];
int rad_type[RAD_MAX]; 	// 0 normal, 1 in eliptical coordinates
double r_ecoff[0]; 	// cooficients for drift of radiants in ecliptic coordinates
int r_n=0;

// SOL dates

double sol_met, sol_beg, sol_end, sol_max;
int sol_rad;

// radiant parameters derived

double r_lam, r_beta;
double r_ra2, r_dec2;
double radius;
double r_ra3[3], r_dec3[3];

// date vector

int date[3];

// meteor parameters derived

double hb, dise;
double omega, dvel;

// variables to choose best radiant

double velmin;
int radmin;

// some iteration variables

int i,j,k,l,m,n;

//------ reading files ----------//

OBS=fopen(argv[1],"r");
while((fscanf(OBS,"%lf %lf %lf %lf %lf %lf %d %s %s %d %d %d %d %d %d %d %s",&ra[0],&dec[0],&ra[1],&dec[1],&mag,&vel,&imoplace,&code,&idobs,&dayb,&daye,&mnt,&year,&ho,&min,&no,&class))!=EOF)
        {
	;
	}
fclose(OBS);

if(ra[0]>361 || dec[0]>91 || ra[1]>361 || dec[1]>91)
	{
	printf("CLASS %d NPL\n",no);
	exit(0);
	} 

SITE=fopen("site.dat","r");
while((fscanf(SITE,"%d %lf %c %lf %c",&pl_code[pl_n],&pl_long[pl_n],&sig1,&pl_lat[pl_n],&sig2))!=EOF)
	{
	if(sig1=='W') { pl_long[pl_n]=pl_long[pl_n]*(-1);}
	if(sig2=='S') { pl_lat[pl_n]=pl_lat[pl_n]*(-1);}
	//printf("%d %lf %lf\n",pl_code[pl_n],pl_long[pl_n],pl_lat[pl_n]);
	if(pl_code[pl_n]==imoplace) pl_n++;
	}
fclose(SITE);

RAD=fopen(argv[2],"r");
while((fscanf(RAD,"%s %lf %lf %d %d %d %d %d %d %lf %lf %lf",&rad[r_n],&r_ra[r_n],&r_dec[r_n],&r_date[r_n][0],&r_date[r_n][1],&r_date[r_n][2],&r_date[r_n][3],&r_date[r_n][4],&r_date[r_n][5],&r_vel[r_n],&r_a[r_n],&r_b[r_n]))!=EOF)
        {
	//printf("%c%c%c %lf %lf %d %d %d %d %d %d %lf %lf %lf\n",rad[r_n][0],rad[r_n][1],rad[r_n][2],r_ra[r_n],r_dec[r_n],r_date[r_n][0],r_date[r_n][1],r_date[r_n][2],r_date[r_n][3],r_date[r_n][4],r_date[r_n][5],r_vel[r_n],r_a[r_n],r_b[r_n]);
	for(i=0;i<6; i++) {stat[r_n][i]=0;}
	prob[r_n]=99;
	rad_type[r_n]=0;
	r_n++;
        }
fclose(RAD);

//------ calculate lamda_sol of event and good date for event -------//

date[0]=year;
date[1]=mnt; 
date[2]=dayb;

check_date(year,mnt,dayb,ho,min,0,ho,min,0,date);
sol_met=sol(date[0],date[1],date[2],ho,min,0,ho,min,0);

// RAD 
// ANT 1.000  198.00  0.000 0.000 11 13 10 01 31 18.0  0.0 0 0
// rad[r_n] r_ecoff[0], r_ecoff[1], r_ecoff[2], r_ecoff[3]

RAD_EKL=fopen(argv[3],"r");
while((fscanf(RAD_EKL,"%s %lf %lf %lf %lf %d %d %d %d %lf %lf %lf",&rad[r_n],&r_ecoff[0],&r_ecoff[1],&r_ecoff[2],&r_ecoff[3],&r_date[r_n][0],&r_date[r_n][1],&r_date[r_n][2],&r_date[r_n][3],&r_vel[r_n],&r_a[r_n],&r_b[r_n]))!=EOF)
	{
	// calculate (ra,dec) position for the date on-the-fly

                r_ra3[0] =row(r_ecoff[0]*sol_met+r_ecoff[1],r_ecoff[2]*sol_met+r_ecoff[3],0);
                r_dec3[0]=row(r_ecoff[0]*sol_met+r_ecoff[1],r_ecoff[2]*sol_met+r_ecoff[3],1);
	
	//printf("r_ecoff[0] %.2lf sol_met %.2lf r_ecoff[1] %.2lf r_ecoff[2] %.2lf r_ecoff[3] %.2lf\n",r_ecoff[0],sol_met,r_ecoff[1],r_ecoff[2],r_ecoff[3]);
	//printf("ra0 %.2lf dec0 %.2lf\n",r_ra3[0],r_dec3[0]);		
	
                r_ra3[1] =row(r_ecoff[0]*sol_met+r_ecoff[1]-2,r_ecoff[2]*sol_met+r_ecoff[3],0);
                r_dec3[1]=row(r_ecoff[0]*sol_met+r_ecoff[1]-2,r_ecoff[2]*sol_met+r_ecoff[3],1);
                r_ra3[2] =row(r_ecoff[0]*sol_met+r_ecoff[1]+2,r_ecoff[2]*sol_met+r_ecoff[3],0);
                r_dec3[2]=row(r_ecoff[0]*sol_met+r_ecoff[1]+2,r_ecoff[2]*sol_met+r_ecoff[3],1);
			
		for(j=0;j<3;j++)
		{
		rad[r_n+j][0]=rad[r_n][0]; rad[r_n+j][1]=rad[r_n][1]; rad[r_n+j][2]=rad[r_n][2];
		r_ra[r_n+j]=r_ra3[j]; r_dec[r_n+j]=r_dec3[j];
		//printf("tutaj %lf %lf %d\n",r_ra3[j],r_dec3[j],r_n+j);
		for(i=0;i<6; i++) {stat[r_n+j][i]=0;}
		for(i=0;i<6; i++) {r_date[r_n+j][i]=r_date[r_n][i];}
		r_vel[r_n+j]=r_vel[r_n];
		prob[r_n+j]=99;
		rad_type[r_n+j]=-1;	
		}
		
		rad_type[r_n]=1;		

		r_n=r_n+3;
	}

//------ check which radiant is a source for this event ------//

	for(i=0;i<r_n;i++)
	{

	//printf("---- %c%c%c %c%c%c%c%c %d --- \n",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
        //printf("r_n %d\n",r_n);
	//printf("%d %d %d %d\n",r_date[i][0],r_date[i][1],r_date[i][2],r_date[i][3]);

	sol_beg=sol(year,r_date[i][0],r_date[i][1],0,0,0,0,0,0);
	sol_max=sol(year,r_date[i][4],r_date[i][5],0,0,0,0,0,0);
	sol_end=sol(year,r_date[i][2],r_date[i][3],0,0,0,0,0,0);

	//printf("sol_met: %lf sol_beg: %lf sol_max: %lf sol_end: %lf\n",sol_met,sol_beg,sol_max,sol_end);
	
	// if event is in the actvity of given stream
	// then we analyse it

	if( (rad_type[i]==0 && sol_met> sol_beg && sol_met<sol_end) || ( (rad_type[i]==1 || rad_type[i]==-1) && sol_end<sol_beg && sol_met<sol_end) || ((rad_type[i]==1 || rad_type[i]==-1) &&  sol_end<sol_beg && sol_met>sol_beg))
	{
	printf("------------------------------------------\n");
	printf("---- %c%c%c %c%c%c%c%c %d --- \n",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);	
	printf("------------------------------------------\n");

	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("sol_met: %lf sol_beg: %lf sol_max: %lf sol_end: %lf\n",sol_met,sol_beg,sol_max,sol_end);
	stat[i][0]=1;	

	//printf("sol_met: %lf sol_beg: %lf sol_max: %lf sol_end: %lf\n",sol_met,sol_beg,sol_max,sol_end);

// calculate postion of radiant for given date:
//
// 1. derive sol_met-sol_max
// 2. compute postion of radiant in eliptical coordiates
// 3. subtract sol_met-sol_max from lambda
// 4. go back to (ra,dec)
// 5. then transform to horizontal to check its hight above
// horizon for given time
	

	if(rad_type[i]==0)
	{
	r_lam=ekl(r_ra[i],r_dec[i],0);
	r_beta=ekl(r_ra[i],r_dec[i],1);
	r_lam=dryf(r_ra[i],r_dec[i],sol_met-sol_max);
	printf("lam: %lf beta: %lf\n",r_lam,r_beta);
	r_ra2=row(r_lam,r_beta,0);
	r_dec2=row(r_lam,r_beta,1);
	}

	if(rad_type[i]==1 || rad_type[i]==-1)
	{
	r_ra2=r_ra[i];
	r_dec2=r_dec[i];
	printf("lam: %lf beta: %lf\n",r_lam,r_beta);
	//if(i==1) printf("%lf ra0 %.2lf dec0 %.2lf\n",sol_met,r_ra[i],r_dec[i]);
	}	

	//printf("%d %lf %lf %lf %lf\n",rad_type[i],r_ra2,r_dec2,r_lam,r_beta);
	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("rad_type: %d pozycja %c%c%c rad_ra: %lf rad_dec: %lf rad_ra2: %lf rad_dec2: %lf\n",rad_type[i],rad[i][0],rad[i][1],rad[i][2],r_ra2,r_dec2,r_ra2,r_dec2);

//	printf("%lf %lf\n",sid(date[0],date[1],date[2],ho,min),alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0]));

	// 1. radiants altitute criterium
	// it is set:
	// for meteors h_rad > 10
	// for fireballs (<=-4.0 mag) h_rad > 5

	if(mag>-4.0 && alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0])>10) stat[i][1]=1;
	if(mag<=-4.0 && alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0])>5) stat[i][1]=1;
	if(mag>-4.0 && alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0])<=10) stat[i][1]=0;
	if(mag<=-4.0 && alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0])<=5) stat[i][1]=0; 
	
	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("alt: %lf\n",alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0]));

	// printf("%.3lf %.3lf %.3lf %.3lf %.3lf %.3lf\n",r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i]);

	// 2. radiant as a target for this event

	if(rad_type[i]==0) radius=radii(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],0);
	if(rad_type[i]==1 && rad[i][0]=='A' && rad[i][1]=='N' && rad[i][2]=='T') radius=radiiekl(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],r_b[i],0);
	if(rad_type[i]==1 && rad[i][0]=='N' && rad[i][1]=='T' && rad[i][2]=='A') radius=radiiekl(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],r_b[i],0);
	if(rad_type[i]==1 && rad[i][0]=='S' && rad[i][1]=='T' && rad[i][2]=='A') radius=radiiekl(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],r_b[i],0);
	if(rad_type[i]==-1 && rad[i][0]=='A' && rad[i][1]=='N' && rad[i][2]=='T') radius=0.75*radiiekl(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],r_b[i],0);
	if(rad_type[i]==-1 && rad[i][0]=='N' && rad[i][1]=='T' && rad[i][2]=='A') radius=0.75*radiiekl(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],r_b[i],0);
	if(rad_type[i]==-1 && rad[i][0]=='S' && rad[i][1]=='T' && rad[i][2]=='A') radius=0.75*radiiekl(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],r_a[i],r_b[i],0);


	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("radius: %lf\n",radius);
	// printf("%lf\n",war2b(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],radius));

	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	stat[i][2]=war2b(r_ra2,r_dec2,ra[0],dec[0],ra[1],dec[1],radius);

	// 3. lenght of event

	if(alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0])>30)
	{
	if(tricos(ra[0],dec[0],ra[1],dec[1])*2<=tricos(r_ra2,r_dec2,ra[1],dec[1])+radius || mag>-4) stat[i][3]=1;
	if(tricos(ra[0],dec[0],ra[1],dec[1])*2>tricos(r_ra2,r_dec2,ra[1],dec[1])+radius && mag<=-4) stat[i][3]=0;
	}
	
	if(alt(date[0],date[1],date[2],ho,min,r_ra2,r_dec2,pl_lat[0],pl_long[0])<=30)
	{
	stat[i][3]=1;
	}

	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("be: %lf re: %lf\n",tricos(ra[0],dec[0],ra[1],dec[1]),tricos(r_ra2,r_dec2,ra[1],dec[1]));
	// 4. velocity of this event	

	hb=alt(date[0],date[1],date[2],ho,min,ra[0],dec[0],pl_lat[0],pl_long[0]);
	dise=r2d*tricos(r_ra2,r_dec2,ra[1],dec[1]);
	
	printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("hb: %.2lf dise: %.2lf\n",hb,dise);

	omega=r2d/100*r_vel[i]*sin(hb*d2r)*sin(dise*d2r);		
	dvel=dvelrozne(omega,-1);

	if( (omega>vel-dvel && omega<vel+dvel) ) { stat[i][4]=1; prob[i]=fabs(omega-vel); }
	if( (omega>=vel+dvel || omega<=vel-dvel) ) stat[i][4]=0;

        printf("--- %c%c%c %c%c%c%c%c %d\t",rad[i][0],rad[i][1],rad[i][2],code[0],code[1],code[2],code[3],code[4],no);
	printf("rad: %c%c%c vel_teo: %lf vel_obs: %lf dvel: %lf\n",rad[i][0],rad[i][1],rad[i][2],omega,vel,dvel);

	// 5. meteor does go from the radiant not from the opposite direction

	if(tricos(r_ra2,r_dec2,ra[1],dec[1])>tricos(r_ra2,r_dec2,ra[0],dec[0])) stat[i][5]=1;
	if(tricos(r_ra2,r_dec2,ra[1],dec[1])<=tricos(r_ra2,r_dec2,ra[0],dec[0])) stat[i][5]=0;

	}

	}

// we check which event is the best one
// if none has all fields 1 then it is a sporadic event

velmin=99;
radmin=-1;

printf("-----------------------------------------------------------\n");
printf("RAD\tINPER\tALT\tTARGET\tLENGHT\tVEL\tVECTOR\tDVEL\n");

for(i=0;i<r_n;i++)
	{
	k=0;
	if(stat[i][0]==1) printf("%c%c%c\t",rad[i][0],rad[i][1],rad[i][2]);
	for(j=0;j<6;j++) 
		{
		if(stat[i][0]==1) printf("%d %d\t",j,stat[i][j]);
		if(stat[i][j]==1) k++;
		}
	if(stat[i][0]==1) printf("%.1lf\n",prob[i]);
	if(k==6) 
		{
		stat[i][6]=1;
		if(prob[i]<velmin) { radmin=i; velmin=prob[i];}
		}
	}

printf("-----------------------------------------------------------\n");

if(radmin>=0) printf("CLASS %d %c%c%c\n",no,rad[radmin][0],rad[radmin][1],rad[radmin][2]);
if(radmin<0) printf("CLASS %d SPO\n",no);


}
